/*  Tilem, TI-Linux Emulator
 *  Copyright (C) 2001 Solignac Julien <x1cygnus@xcalc.org>
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License as published by the Free Software Foundation; either
 *  version 2.1 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include "Z80.h"
#include <stdio.h>
#include <string.h>
#include "Z80Dasm.h"

byte enabled = 0;

void refreshdebugger(unsigned int xpc);
void create_debugger(Z80_Regs *R);

G_LOCK_DEFINE(halted);
void Z80_Debug (Z80_Regs *R)
{
	gdk_threads_enter();

		if (!enabled) {
			enabled = 1;
			create_debugger(R);
		}

		refreshdebugger(R->PC.D);

	gdk_threads_leave();

	G_LOCK(halted);
	G_LOCK(halted);
	G_UNLOCK(halted);
	return;
}

/*void Z80_Debug (Z80_Regs *R)
{
	static unsigned int ancient;
	static byte act = 0;
 byte buf[5];
 char flags[]="SZ.H.VNC";
 char S[20],f[9];
 int i;
 buf[0]=Z80_RDMEM(R->PC.D); i=1;
 switch (buf[0])
 {
  case 0xCB:
  case 0xED:
   buf[1]=Z80_RDMEM((R->PC.D+1)&0xFFFF); i=2;
   break;
  case 0xDD:
  case 0xFD:
   buf[1]=Z80_RDMEM((R->PC.D+1)&0xFFFF); i=2;
   if (buf[1]==0xCB)
   {
    buf[2]=Z80_RDMEM((R->PC.D+2)&0xFFFF);
    buf[3]=Z80_RDMEM((R->PC.D+3)&0xFFFF);
    i=4;
   }
 }
 for (;i<5;++i) { buf[i]=Z80_RDMEM((R->PC.D+i)&0xFFFF); }
 Z80_Dasm (buf,S,R->PC.D);
 for (i=strlen(S);i<19;++i) S[i]=' ';
 S[19]='\0';
 for (i=7;i>=0;--i) { f[7-i]=(R->AF.D&(1<<i))? flags[7-i]:'.'; }
 f[8]='\0';

if (R->PC.D == 0x076B)
	act = 1;
if (!act)
	return;
if (ancient != R->PC.D) {
 printf ("%04X: %s  AT SP: %04X %04X  FLAGS: %s\n",R->PC.D,S,
          Z80_RDMEM(R->SP.D)+Z80_RDMEM((R->SP.D+1)&0xFFFF)*256,
          Z80_RDMEM((R->SP.D+2)&0xFFFF)+Z80_RDMEM((R->SP.D+3)&0xFFFF)*256,f);
 printf ("%27sAF:%04X BC:%04X DE:%04X HL:%04X IX:%04X IY:%04X\n",
           "",R->AF.D,R->BC.D,R->DE.D,R->HL.D,R->IX.D,R->IY.D);

	ancient = R->PC.D;
}
}*/
