/*  Tilem, TI-Linux Emulator
 *  Copyright (C) 2001 Solignac Julien <x1cygnus@xcalc.org>
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License as published by the Free Software Foundation; either
 *  version 2.1 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

/*#define DEBUG
#define TRACE*/

#include<gtk/gtk.h>
#include<unistd.h>

#define LSB_FIRST
#include "Z80.c"
#include "Z80Debug.c"

extern struct hardware *hw;

G_LOCK_DEFINE(running);
volatile byte running;

/******************************/
/*     General Core Data      */
/******************************/
byte *lcdbuf;

void core(void *args)
{
	G_LOCK_EXTERN(cleanquit);
	G_LOCK_EXTERN(scrref);
	extern byte ctrlspeed;
	byte i = 0;

	GTimer *freqmeter;
	gulong timereg;
/* I don't know wheather I'll have to use Gdk_Threads_Enter to use the timer
 * so for the moment I'll leave it out and 'wait and see'... */

	running = 1;
	G_LOCK(cleanquit);

	puts("Starting Z80 Emulation Core...");

	Z80_Reset();
	Rezet(1);

	freqmeter = g_timer_new();
	g_timer_start(freqmeter);
	
	while (1) {
		G_LOCK(running);
		if (!running)
			break;
		G_UNLOCK(running);

		Z80_Execute();

		if (i == 0) {
			i = 4;
			G_UNLOCK(scrref);
		}
		i--;

/* Executes 50000 cycles at a time */
		g_timer_elapsed(freqmeter, &timereg);
		if ((timereg < 3750) && (ctrlspeed))
			usleep(3750 - timereg);

		g_timer_reset(freqmeter);
	}

	g_timer_destroy(freqmeter);
	G_UNLOCK(cleanquit);
}
