/****************************************************************************/
/* Read a byte from given memory location                                   */
/****************************************************************************/
unsigned Z80_RDMEM(dword A);

/****************************************************************************/
/* Write a byte to given memory location                                    */
/****************************************************************************/
void Z80_WRMEM(dword A, byte V);

/****************************************************************************/
/* Input a byte from given I/O port                                         */
/****************************************************************************/
byte Z80_In(byte Port);

/****************************************************************************/
/* Output a byte to given I/O port                                          */
/****************************************************************************/
void Z80_Out(byte Port, byte Value);

/****************************************************************************/
/* Handle keyboard signals                                                  */
/****************************************************************************/
void emkeyin(unsigned short keyv, byte i);
void emkeyup(unsigned short keyv, byte i);

/****************************************************************************/
/* Reset Calc                                                               */
/****************************************************************************/
void Rezet(byte i);

/****************************************************************************/
/* Allocate/Free necessary memory                                           */
/****************************************************************************/
byte initmem(void);
void cleanmem(void);

#define Z80_RDMEM(A)	(hw->xZ80_RDMEM)(A)
#define Z80_WRMEM(A,v)	(hw->xZ80_WRMEM)(A,v)
#define Z80_In(v)	(hw->xZ80_In)(v)
#define Z80_Out(p,v)	(hw->xZ80_Out)(p,v)
#define emkeyin(v,i)	(hw->xemkeyin)(v,i)
#define emkeyup(v,i)	(hw->xemkeyup)(v,i)
#define Rezet(i)	(hw->xRezet)(i)
#define initmem()	(hw->xinitmem)()
#define cleanmem()	(hw->xcleanmem)()

struct hardware {
	char		model;
	byte		(*xinitmem)	(void);
	void		(*xcleanmem)	(void);
	void		(*xRezet)	(byte);
	byte		(*xZ80_In)	(byte);
	void		(*xZ80_Out) 	(byte, byte);
	void		(*xZ80_WRMEM)	(dword, byte);
	unsigned	(*xZ80_RDMEM)	(dword);
	void		(*xemkeyin)	(unsigned short, byte);
	void		(*xemkeyup)	(unsigned short, byte);
};
