/*  TilEm, TI-Linux Emulator
 *  Copyright (C) 2001 Solignac Julien <x1cygnus@xcalc.org>
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License as published by the Free Software Foundation; either
 *  version 2.1 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
char* ahome(char *text);


void xp_Rezet(byte i)
{
	extern Z80_Regs R;
	extern byte lcdshow;
	FILE *rfile;

	lcdmode = xlcd = ylcd = 0;
	port2 = 0;
	port4 = 100000;
	onkey = 0;
	tilnk = 0;
	pclnk = 0x03;

	pager[0] = 0x00;
	pager[1] = 0x06; 
	pager[2] = 0x21; 
	pager[3] = 0x20;

	memset(mpages + 0x20 * 0x4000, 0x00, 0x02 * 0x4000);
	if (i == 0) return;

	if ((rfile = fopen(ahome("xp.sav"), "r"))) {
		lcdshow = 1;
		fread(pager, sizeof(byte), 4, rfile);
		fread(&R, sizeof(byte), sizeof(Z80_Regs), rfile);
		fread(mpages + 0x20 * 0x4000, sizeof(byte), 0x02 * 0x4000 + 0x300, rfile);
		lcdmode = fgetc(rfile);
		xlcd = fgetc(rfile);
		ylcd = fgetc(rfile);
		fclose(rfile);
	}
}


byte xp_initmem(void)
{
	FILE *rfile;

	puts(">>> Ti-83+");
	if (!(mpages = malloc((0x20 + 2) * 0x4000 + 0x300)))  {
		fprintf(stderr, "Error Allocating Memory\n");
		return(0);
	}

	lcdbuf = mpages + (0x20 + 2) * 0x4000;
	memset(lcdbuf, 0xFF, 0x300);

	if (!(rfile = fopen(ahome("xp.rom"), "r"))) {
		fprintf(stderr, "Rom File IO Error\n");
		return(0);
	}
	
	if (fread(mpages, sizeof(byte), 0x20 * 0x4000, rfile) != 0x20 * 0x4000) {
		fprintf(stderr, "Rom File Corrupted\n");
		return(0);
	}

	fclose(rfile);

	return(1);
}


void xp_cleanmem()
{
	extern byte savecode;
	extern Z80_Regs R;

	FILE *rfile;

	if (savecode) {
		if (!(rfile = fopen(ahome("xp.rom"), "w"))) return;
		fwrite(mpages, sizeof(byte), 0x20 * 0x4000, rfile);
		fclose(rfile);

		if (!(rfile = fopen(ahome("xp.sav"), "w"))) return;
		fwrite(pager, sizeof(byte), 4, rfile);
		fwrite(&R, sizeof(byte), sizeof(Z80_Regs), rfile);
		fwrite(mpages + 0x20 * 0x4000, sizeof(byte), 0x02 * 0x4000 + 0x300, rfile);
		fputc(lcdmode, rfile);
		fputc(xlcd, rfile);
		fputc(ylcd, rfile);
		fclose(rfile);
	}

	free(mpages);
}
