/*  Tilem, TI-Linux Emulator
 *  Copyright (C) 2001 Solignac Julien <x1cygnus@xcalc.org>
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License as published by the Free Software Foundation; either
 *  version 2.1 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include<gdk/gdkkeysyms.h>
#include "../../Z80.h"
extern Z80_Regs R;

/* Down    Left    Right   Up                                      *
 * Enter   Plus    Minus   Times   Divide  Power   Clear           *
 * (-)     3       6       9       )       Tan     Vars            *
 * Point   2       5       8       (       Cos     Prgm    Stat    *
 * 0       1       4       7       ,       Sin     Apps    X,T...  *
 * [On]    Sto     Ln      Log     Square  Inverse Math    Alpha   * 
 * Graph   Trace   Zoom    Window  Y=      2nd     Mode    Del     */

/* ------- Keyboard Map --------- */
static unsigned short keycodes[] = {GDK_Down, GDK_Left, GDK_Right, GDK_Up, 0x0000, 0x0000, 0x0000, 0x0000,
	GDK_Return, GDK_KP_Add, GDK_KP_Subtract, GDK_KP_Multiply, GDK_KP_Divide, GDK_Up, GDK_Escape, 0x0000,
	GDK_minus, GDK_KP_3, GDK_KP_6, GDK_KP_9, GDK_parenright, GDK_t, GDK_v, 0x0000,
	GDK_KP_Decimal, GDK_KP_2, GDK_KP_5, GDK_KP_8, GDK_parenleft, GDK_c, GDK_Tab, GDK_s,
	GDK_KP_0, GDK_KP_1, GDK_KP_4, GDK_KP_7, GDK_comma, GDK_e, GDK_a, GDK_x,
	GDK_BackSpace, GDK_greater, GDK_l, GDK_o, GDK_twosuperior, GDK_ampersand, GDK_m, GDK_Shift_L,
	GDK_F5, GDK_F4, GDK_F3, GDK_F2, GDK_F1, GDK_Control_L, GDK_F6, GDK_Delete};


/* ------ Keyboard Matrix ------- */
static byte scode[7] = {0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF};


/* ------------------------------ */
byte pclnk, *mpages;
static unsigned int port4, onkey;
unsigned char lcdinc, lcdmode, xlcd, ylcd;
static byte keymask, tilnk, port2, lcddummyread, pager[4];

/* ------------------------------ */
extern byte *lcdbuf;
