/*  TilEm, TI-Linux Emulator
 *  Copyright (C) 2001 Solignac Julien <x1cygnus@xcalc.org>
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License as published by the Free Software Foundation; either
 *  version 2.1 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */


void xp_Z80_WRMEM(dword A, byte v)
{
	static byte flashlock = 0;

	if ((A >= 0x4000) && (A < 0x8000)) {
		if (((A == 0x6AAA) && (v == 0xAA) && (!flashlock))
			|| ((A == 0x5555) && (v == 0x55) && (flashlock == 0x01)) 
			|| ((A == 0x6AAA) && (v == 0xA0) && (flashlock == 0x02))) {
			flashlock++;

		} else if (flashlock == 0x03) {
			*(mpages + 0x4000 * pager[1] + (A & 0x3FFF)) = v;
			flashlock = 0x00;

		} else {
			flashlock = 0x00;

		}
	}

	if (A >= 0x8000) {
		*(mpages + 0x4000 * pager[(A)>>14] + (A & 0x3FFF)) = v;
		if (((A < 0xC000) && (pager[2] < 0x20)) || ((A >= 0xC000) && (pager[3] < 0x20))) {
			puts("** attempt to write to ROM **");
		}
	}
}


unsigned xp_Z80_RDMEM(dword A)
{
	A &= 0xFFFF;

/* Bitmask for apps, starting with bit 1, 0 = Enabled, 1 = Disabled ;) */
	if ((pager[1] == 0x1E) && ((A == 0x4000 + 0x1FE0) || (A == 0x4000 + 0x1FE1)))
		return(0x00);

	return(*(mpages + 0x4000 * pager[(A)>>14] + (A & 0x3FFF)));
}
