#include<string.h>
#include<pthread.h>

#include "../main.h"


#define nummodels 2
static GtkWidget *dlg;
extern struct hwmodel hwmodels[nummodels];

void dochangehw(GtkWidget *entry)
{
	extern GtkWidget *Screen;
	G_LOCK_EXTERN(running);
	extern guint timerid;
	extern byte iskeyb;

	byte i, *text;

	G_LOCK(running);
	cleanmem();
/* strange enough, no segfault */

	text = gtk_entry_get_text(GTK_ENTRY(entry));
	for (i = 0; i < nummodels; i++) {
		if (!(strcmp(text, hwmodels[i].name)))
			hw = hwmodels[i].hx;
	}

	if (!initmem())
		exit(-1);
	Z80_Reset();
	Rezet(1);

	G_UNLOCK(running);

	gtk_timeout_remove(timerid);
	gtk_signal_disconnect_by_func(GTK_OBJECT(Screen), GTK_SIGNAL_FUNC(exit_emulator), NULL);
	gtk_widget_destroy(Screen);

	create_Screen(iskeyb);

	gtk_widget_destroy(dlg);
}


void changehw(void)
{
	byte i, fname[7];

	GtkWidget *vis, *frame, *selector, *selentry, *dialog_aa, *bbox, *button1, *button2;
	GList *selector_items = NULL;

	dlg = gtk_dialog_new();
		gtk_window_set_title(GTK_WINDOW(dlg), "Emulated Calculator");
		gtk_window_set_modal(GTK_WINDOW(dlg), TRUE);

	button1 = gtk_button_new_with_label("Ok");
	gtk_widget_show(button1);

	button2 = gtk_button_new_with_label("Cancel");
	gtk_widget_show(button2);

	bbox = gtk_hbutton_box_new();
		gtk_container_add(GTK_CONTAINER(bbox), button1);
		gtk_container_add(GTK_CONTAINER(bbox), button2);
	gtk_widget_show(bbox);

	dialog_aa = GTK_DIALOG(dlg)->action_area;
		gtk_container_set_border_width(GTK_CONTAINER(dialog_aa), 10);
		gtk_box_pack_start(GTK_BOX(dialog_aa), bbox, TRUE, TRUE, 0);
	gtk_widget_show(dialog_aa);

	selector = gtk_combo_new();
		gtk_container_set_border_width(GTK_CONTAINER(selector), 5);

		for (i = 0; i < nummodels; i++) {
			snprintf(fname, 7, "x%c.rom", hwmodels[i].hx->model);
			if (!(access(ahome(fname), R_OK)))
				selector_items = g_list_append(selector_items, hwmodels[i].name);
		}

		gtk_combo_set_popdown_strings(GTK_COMBO(selector), selector_items);
		g_list_free(selector_items);
	gtk_widget_show(selector);

	selentry = GTK_COMBO(selector)->entry;
		gtk_entry_set_editable(GTK_ENTRY(selentry), FALSE);
	gtk_widget_show(selentry);

	frame = gtk_frame_new("Pick calculator");
		gtk_container_set_border_width(GTK_CONTAINER(frame), 5);
		gtk_container_add(GTK_CONTAINER(frame), selector);
	gtk_widget_show(frame);

	vis = GTK_DIALOG(dlg)->vbox;
		gtk_box_pack_start(GTK_BOX(vis), frame, TRUE, TRUE, 0);
	gtk_widget_show(vis);

		gtk_signal_connect_object(GTK_OBJECT(selentry), "activate", GTK_SIGNAL_FUNC(dochangehw), GTK_OBJECT(selentry));
		gtk_signal_connect_object(GTK_OBJECT(button1), "clicked", GTK_SIGNAL_FUNC(dochangehw), GTK_OBJECT(selentry));
		gtk_signal_connect_object(GTK_OBJECT(button2), "clicked", GTK_SIGNAL_FUNC(gtk_widget_destroy), GTK_OBJECT(dlg));
		gtk_signal_connect_object(GTK_OBJECT(dlg), "destroy", GTK_SIGNAL_FUNC(gtk_widget_destroy), GTK_OBJECT(dlg));
		gtk_widget_grab_focus(dlg);
	gtk_widget_show(dlg);
}
