/*#include<stdio.h>*/

#define numentrys 9

typedef void (*menufunc) (void);
struct menudat
{
	char *label;
	menufunc func;
};

void changehw(void);

extern struct hardware *hw;

static struct menudat menuinfo[numentrys] = {
			{"Load Ram File/Flash App (F12)", create_loaddlg},
			{"Open Debuggger (F10)", invokeemu},
			{"Real/Full speed", toggle_speed},
			{"Toggle Window", togglescr},
			{"Change Calculator", changehw},
			{"Reset Calculator", initstat},
			{"Revert to saved state", revertstat},
			{"Exit with saving", exit_emulator},
			{"Exit without saving", exit_nosave}
};

static gint show_menu(GtkWidget *widget, GdkEvent *event)
{
	extern struct hardware *hw;

	byte tx = 0xFF, ty = 0xFF, val = 0xFF;
	GdkEventButton *bevent = (GdkEventButton *) event; 

	if ((event->type == GDK_BUTTON_PRESS) && (bevent->button != 1)) {
		gtk_menu_popup(GTK_MENU(widget), NULL, NULL, NULL, NULL, bevent->button, bevent->time);
		return(TRUE);
	}

	if (((event->type == GDK_BUTTON_PRESS) || (event->type == GDK_BUTTON_RELEASE)) && (bevent->button == 1)) {

		if ((bevent->x > 20) && ((((int) bevent->x - 20) % 40) < 32)) {
			tx = (bevent->x - 20) / 40;

			if ((bevent->y > 187) && (bevent->y < 199))
				ty = 0;	

			if ((bevent->y > 230) && ((((int) bevent->y - 230) % 28) < 19))
				ty = (bevent->y - (230 - 28)) / 28;
		}

		if (((tx  >= 3) && (ty <= 2) && (ty != 0)) || (tx > 4) || (ty > 9))
			tx = ty = 0xFF;

		if ((bevent->x > 139) && (bevent->y > 215) && (bevent->y < 275) && (bevent->x < 218)) {
			if ((bevent->y > 228) && (bevent->y < 262)) {
				if (bevent->x < 162) val = 0x01;
				if (bevent->x > 197) val = 0x02;
			} else if ((bevent->x > 158) && (bevent->x < 197)) {
				if (bevent->y > 256) val = 0x00;
				if (bevent->y < 234) val = 0x03;
			}

		}

		if (tx != 0xFF) {
			if (ty >= 2)
				val = 8 * (5 - tx) + (9 - ty);

			if (ty <= 1)
				val = (6 * 8) + (ty?(5 + tx):(4 - tx));

		}

		if (val != 0xFF) {
			if (event->type == GDK_BUTTON_RELEASE)
				emkeyup(0x00, val);
			else
				emkeyin(0x00, val);
		}
		return(TRUE);
	}


	return(FALSE);
}

void create_menus(GtkWidget *window)
{
	GtkWidget *menu, *menu_items;
	int i;

	gtk_widget_add_events(window, GDK_BUTTON_PRESS_MASK | GDK_BUTTON_RELEASE_MASK);

	menu = gtk_menu_new();

	for (i = 0; i < numentrys; i++) {
		menu_items = gtk_menu_item_new_with_label(menuinfo[i].label);
		gtk_menu_append(GTK_MENU(menu), menu_items);
		gtk_signal_connect_object(GTK_OBJECT(menu_items), "activate", GTK_SIGNAL_FUNC(menuinfo[i].func), NULL);
		gtk_widget_show(menu_items);
	}

	gtk_signal_connect_object(GTK_OBJECT(window), "event", GTK_SIGNAL_FUNC(show_menu), GTK_OBJECT(menu));
}
