/*  Tilem, TI-Linux Emulator
 *  Copyright (C) 2001 Solignac Julien <x1cygnus@xcalc.org>
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License as published by the Free Software Foundation; either
 *  version 2.1 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include<sys/types.h>
#include<sys/stat.h>
#include<gtk/gtk.h>
#include<pthread.h>
#include<unistd.h>
#include<stdio.h>

#include "core/Z80.h"
#include "core/dep/inter.h"
#include "main.h"


struct hwmodel hwmodels[2] = {
	{"TI-83", &x3},
	{"TI-83+", &xp}
};

int main (int argc, char *argv[])
{
	extern struct hardware *hw;

	pthread_t cthread;

	hw = hwmodels[1].hx;

	g_thread_init(NULL);
	gtk_init(&argc, &argv);

/****** ROM Wizard ******/
	if (access(ahome(""), R_OK)) {
		puts("Running TilEm for the first time...");
//		mkdir(ahome(""), S_IRWXU);
		printf("You'll need to move all your ROM files  to a directory named ~/.TilEm/\n" \
			" - TI-83+ file is named xp.rom\n" \
			" - TI-83 file is named x3.rom\n");
		exit(-1);
	}
//	create_rwizard();


	gtk_rc_parse_string("style \"monospaced\" { font = \"-*-courier-medium-r-normal--12-*-*-*-*-*-*-*\" } widget \"*monow*\" style \"monospaced\"");

	if (!initmem())
		exit(-1);

	pthread_create(&cthread, NULL, (void *) &core, (void *) *argv);

	create_Screen(1);

	gdk_threads_enter();
	gtk_main();
	gdk_threads_leave();

	cleanmem();

	puts("Thanks for using Tilem");
	return(0);
}

